/*
clap - CLipboard APpender
Public Domain by Pabs (http://zip.to/pabs3) in 2002
*/

#define WIN32_LEAN_AND_MEAN
#include <windows.h>
#include <shellapi.h>
#include "resource.h"

#define PROGNAME "clap"
#define VERSION "0.0"
#define PROG PROGNAME " " VERSION
#define PROG_CLASS PROG" WndClass"
#define PROG_TITLE PROG" WndTitle"
#define PROG_STATUS PROG" is "

#define NOTIFY_ICON_ID 0xB00B5 /* Hehe */
#define WM_NOTIFY_ICON 0xB007

#define REPLACE_STATUS "replacing"
#define APPEND_STATUS "appending"

/*
#if( sizeof(REPLACE_STATUS)+sizeof(PROG" is ") > 64 )
	#error "REPLACE_STATUS is too big"
#endif

#if( sizeof(APPEND_STATUS)+sizeof(PROG" is ") > 64 )
	#error "APPEND_STATUS is too big"
#endif
*/

/* Replace by default */
char append = 0;

HINSTANCE hInstance;

UINT s_uTaskbarRestart = 0;

HWND msgwin = NULL, hwndNextViewer = NULL;

HMENU menu = NULL;

HICON replace_icon = NULL, append_icon = NULL;

HGLOBAL oem_clip = NULL, text_clip = NULL, unicode_clip = NULL;
DWORD oem_size = 0, text_size = 0, unicode_size = 0;
DWORD oem_len = 0, text_len = 0, unicode_len = 0;

BOOL pay_attention = TRUE;

NOTIFYICONDATA nid = {
	sizeof(nid),
	NULL,
	NOTIFY_ICON_ID,
	NIF_ICON|NIF_MESSAGE|NIF_TIP,
	WM_NOTIFY_ICON,
	NULL,
	PROG_STATUS REPLACE_STATUS
};


HMENU make_menu();
LRESULT CALLBACK WndProc(HWND h, UINT m, WPARAM w, LPARAM l);
void UpdateInternalClipboard();
void EmptyClip();

/* Entry point */
int WINAPI WinMain( HINSTANCE hInst, HINSTANCE hPrevInstance, LPSTR lpCmdLine, int nCmdShow ){
	if( !lstrcmpi( lpCmdLine, "append") || !lstrcmp( lpCmdLine, "1") )
		append = 1;
	else if( !lstrcmpi( lpCmdLine, "replace") || !lstrcmp( lpCmdLine, "0") )
		append = 0;

	hInstance = hInst;

	replace_icon = (HICON)LoadImage(hInstance, MAKEINTRESOURCE(IDI_REPLACE), IMAGE_ICON, 16, 16, LR_DEFAULTCOLOR);
	if( !replace_icon ){
		MessageBox( NULL, "Couldn't load the replace icon!", PROG, MB_OK|MB_SYSTEMMODAL );
		return 0;
	}

	append_icon = (HICON)LoadImage (hInstance, MAKEINTRESOURCE (IDI_APPEND), IMAGE_ICON, 16, 16, LR_DEFAULTCOLOR);
	if( !append_icon ){
		MessageBox( NULL, "Couldn't load the append icon!", PROG, MB_OK|MB_SYSTEMMODAL );
		return 0;
	}

	{
		WNDCLASS wc = {0,WndProc,0,0,hInstance,NULL,NULL,NULL,NULL,PROG_CLASS};
		if( !RegisterClass(&wc) ){
				MessageBox( NULL, "Couldn't create a class for the hidden handler window!", PROG, MB_OK|MB_SYSTEMMODAL );
				return 0;
		}
		msgwin = CreateWindow( PROG_CLASS,PROG_TITLE,WS_POPUP,0,0,16,16,NULL,NULL,hInstance,NULL );
		if( !msgwin ){
			MessageBox( NULL, "Couldn't create a hidden handler window!", PROG, MB_OK|MB_SYSTEMMODAL );
			return 0;
		}
	}

	nid.hWnd = msgwin;
	nid.hIcon = append ? append_icon : replace_icon;
	if( !Shell_NotifyIcon( NIM_ADD, &nid ) ){
		MessageBox( NULL, "Couldn't create a taskbar icon!", PROG, MB_OK|MB_SYSTEMMODAL );
		DestroyWindow( msgwin );
	}

	{
		MSG msg;
		while (GetMessage(&msg, (HWND) NULL, 0, 0))
		{
			TranslateMessage(&msg);
			DispatchMessage(&msg);
		}
	}

	return 0;
}

LRESULT CALLBACK WndProc(HWND h, UINT m, WPARAM w, LPARAM l){
	switch ( m ){
		case WM_CREATE:
			s_uTaskbarRestart = RegisterWindowMessage("TaskbarCreated");
			if( !s_uTaskbarRestart ) return -1;
			hwndNextViewer = SetClipboardViewer(h);
		return 0;
		case WM_CHANGECBCHAIN:
			if ( (HWND)w == hwndNextViewer )
				hwndNextViewer = (HWND)l;
			else if ( hwndNextViewer != NULL )
				SendMessage( hwndNextViewer, m, w, l );
		return 0;
		case WM_DESTROY:
			Shell_NotifyIcon( NIM_DELETE, &nid );
			ChangeClipboardChain( msgwin, hwndNextViewer );
			PostQuitMessage( 0 );
		return 0;
		case WM_DRAWCLIPBOARD:
			if( pay_attention && append ){
				pay_attention = FALSE;
				if( OpenClipboard( msgwin ) ){
					BOOL owned = FALSE;
					HGLOBAL new_oem_clip = NULL, new_text_clip = NULL, new_unicode_clip = NULL;
					HGLOBAL cur_oem_clip = NULL, cur_text_clip = NULL, cur_unicode_clip = NULL;
					cur_oem_clip = GetClipboardData( CF_OEMTEXT );
					cur_text_clip = GetClipboardData( CF_TEXT );
					cur_unicode_clip = GetClipboardData( CF_UNICODETEXT );
					if( cur_oem_clip ){
						UINT flags = GlobalFlags( cur_oem_clip );
						if( !(flags & GMEM_DISCARDED) ){
							DWORD cur_size = GlobalSize( cur_oem_clip );
							if( cur_size ){
								HGLOBAL t;
								BOOL done = FALSE;
								if( oem_clip ) t = GlobalReAlloc( oem_clip, oem_size + cur_size + 1, 0 );
								else t = GlobalAlloc( GMEM_MOVEABLE|GMEM_DDESHARE, cur_size + 1 );
								if( t ){
									BYTE* cur_p;
									oem_size += cur_size + 1;
									oem_clip = t;
									cur_p = GlobalLock( cur_oem_clip );
									if( cur_p ){
										BYTE* p = GlobalLock( oem_clip );
										if( p ){
											DWORD cur_len = 0; BYTE* cp;
											for( cp = cur_p; cur_len <= cur_size && *cp; cp++, cur_len++ );
											strncpy( p+oem_len, cur_p, cur_len );
											oem_size = ( oem_len += cur_len );
											new_oem_clip = GlobalAlloc( GMEM_MOVEABLE|GMEM_DDESHARE, oem_len + 1 );
											if( new_oem_clip ){
												BYTE* new_p = GlobalLock( new_oem_clip );
												if( new_p ){
													strncpy( new_p, p, oem_len );
													new_p[ oem_len ] = 0;
													done = TRUE;
												}
												GlobalUnlock( new_oem_clip );
											}
											GlobalUnlock( oem_clip );
										}
										GlobalUnlock( cur_oem_clip );
									}
								}
							}
						}
					}
					if( cur_text_clip ){
						UINT flags = GlobalFlags( cur_text_clip );
						if( !(flags & GMEM_DISCARDED) ){
							DWORD cur_size = GlobalSize( cur_text_clip );
							if( cur_size ){
								HGLOBAL t;
								BOOL done = FALSE;
								if( text_clip ) t = GlobalReAlloc( text_clip, text_size + cur_size + 1, 0 );
								else t = GlobalAlloc( GMEM_MOVEABLE|GMEM_DDESHARE, cur_size + 1 );
								if( t ){
									BYTE* cur_p;
									text_size += cur_size + 1;
									text_clip = t;
									cur_p = GlobalLock( cur_text_clip );
									if( cur_p ){
										BYTE* p = GlobalLock( text_clip );
										if( p ){
											DWORD cur_len = 0; BYTE* cp;
											for( cp = cur_p; cur_len <= cur_size && *cp; cp++, cur_len++ );
											strncpy( p+text_len, cur_p, cur_len );
											text_size = ( text_len += cur_len );
											new_text_clip = GlobalAlloc( GMEM_MOVEABLE|GMEM_DDESHARE, text_len + 1 );
											if( new_text_clip ){
												BYTE* new_p = GlobalLock( new_text_clip );
												if( new_p ){
													strncpy( new_p, p, text_len );
													new_p[ text_len ] = 0;
													done = TRUE;
												}
												GlobalUnlock( new_text_clip );
											}
											GlobalUnlock( text_clip );
										}
										GlobalUnlock( cur_text_clip );
									}
								}
							}
						}
					}
					if( new_oem_clip || new_text_clip || new_unicode_clip ){
						EmptyClipboard();
						if( new_oem_clip ) SetClipboardData( CF_OEMTEXT, new_oem_clip );
						if( new_text_clip ) SetClipboardData( CF_TEXT, new_text_clip );
						if( new_unicode_clip ) SetClipboardData( CF_UNICODETEXT, new_unicode_clip );
					}
					CloseClipboard();
				}
				pay_attention = TRUE;
 			} else UpdateInternalClipboard();
			SendMessage( hwndNextViewer, m, w, l );
		break;
		case WM_COMMAND:
			switch ( LOWORD( w ) ){
				case IDM_EXIT:
					DestroyWindow( msgwin );
				return 0;
				case IDM_EMPTY:
					EmptyClip();
				return 0;
				case IDM_APPEND:
				case IDM_REPLACE:
					append = ( LOWORD( w ) == IDM_APPEND );
					lstrcpy( nid.szTip+sizeof(PROG_STATUS)-1, append ? APPEND_STATUS : REPLACE_STATUS );
					nid.hIcon = append ? append_icon : replace_icon;
					Shell_NotifyIcon( NIM_MODIFY, &nid );
				return 0;
			}
		break;
		case WM_NOTIFY_ICON:
			if( w == NOTIFY_ICON_ID ){
				switch ( l ){
					case WM_LBUTTONDOWN:
						SendMessage( h, WM_COMMAND,  MAKEWPARAM( append ? IDM_REPLACE : IDM_APPEND, 0 ), 0 );
					break;
					case WM_RBUTTONDOWN:
						if( !menu ){
							HMENU mmenu = LoadMenu( hInstance, MAKEINTRESOURCE(IDR_MENU) );
							if( mmenu ){
								menu = GetSubMenu( mmenu, 0 );
								if( !menu ){
									DestroyMenu(mmenu);
									mmenu = NULL;
								}
							}
						}
						if( menu ){
							POINT pt;
							if( GetCursorPos( &pt ) ){
								MENUITEMINFO mii = {sizeof(mii),MIIM_STATE,0,append ? MFS_UNCHECKED : MFS_CHECKED,0,NULL,NULL,NULL,0,NULL,0};
								SetMenuItemInfo(menu,IDM_REPLACE,FALSE,&mii);
								mii.fState = append ? MFS_CHECKED : MFS_UNCHECKED;
								SetMenuItemInfo(menu,IDM_APPEND,FALSE,&mii);
								TrackPopupMenuEx( menu, TPM_RIGHTBUTTON|TPM_LEFTALIGN|TPM_TOPALIGN, pt.x, pt.y, msgwin, NULL );
							}
						}
					break;
				}
			}
		break;
		default:
			if(m == s_uTaskbarRestart){
				lstrcpy( nid.szTip+sizeof(PROG" is "), append ? APPEND_STATUS : REPLACE_STATUS );
				nid.hIcon = append ? append_icon : replace_icon;
				Shell_NotifyIcon( NIM_ADD, &nid );
			}
	}
	return DefWindowProc(h, m, w, l);
}

void UpdateInternalClipboard(){
	if( OpenClipboard( msgwin ) ){
		HGLOBAL cur_oem_clip = NULL, cur_text_clip = NULL, cur_unicode_clip = NULL;
		cur_oem_clip = GetClipboardData( CF_OEMTEXT );
		cur_text_clip = GetClipboardData( CF_TEXT );
		cur_unicode_clip = GetClipboardData( CF_UNICODETEXT );
		if( cur_oem_clip ){
			UINT flags = GlobalFlags( cur_oem_clip );
			if( !(flags & GMEM_DISCARDED) ){
				DWORD cur_size = GlobalSize( cur_oem_clip );
				if( cur_size ){
					HGLOBAL t;
					if( oem_clip ) t = GlobalReAlloc( oem_clip, cur_size + 1, 0 );
					else t = GlobalAlloc( GMEM_MOVEABLE|GMEM_DDESHARE, cur_size + 1 );
					if( t ){
						BYTE* cur_p;
						oem_size = cur_size + 1;
						oem_clip = t;
						cur_p = GlobalLock( cur_oem_clip );
						if( cur_p ){
							BYTE* p = GlobalLock( oem_clip );
							if( p ){
								DWORD cur_len = 0; BYTE* cp;
								for( cp = cur_p; cur_len <= cur_size && *cp; cp++, cur_len++ );
								strncpy( p, cur_p, cur_len );
								oem_size = oem_len = cur_len;
								GlobalUnlock( oem_clip );
							}
							GlobalUnlock( cur_oem_clip );
						}
					}
				}
			}
		}
		if( cur_text_clip ){
			UINT flags = GlobalFlags( cur_text_clip );
			if( !(flags & GMEM_DISCARDED) ){
				DWORD cur_size = GlobalSize( cur_text_clip );
				if( cur_size ){
					HGLOBAL t;
					if( text_clip ) t = GlobalReAlloc( text_clip, cur_size + 1, 0 );
					else t = GlobalAlloc( GMEM_MOVEABLE|GMEM_DDESHARE, cur_size + 1 );
					if( t ){
						BYTE* cur_p;
						text_size = cur_size + 1;
						text_clip = t;
						cur_p = GlobalLock( cur_text_clip );
						if( cur_p ){
							BYTE* p = GlobalLock( text_clip );
							if( p ){
								DWORD cur_len = 0; BYTE* cp;
								for( cp = cur_p; cur_len <= cur_size && *cp; cp++, cur_len++ );
								strncpy( p, cur_p, cur_len );
								text_size = text_len = cur_len;
								GlobalUnlock( text_clip );
							}
							GlobalUnlock( cur_text_clip );
						}
					}
				}
			}
		}
		CloseClipboard();
	}
}

void EmptyClip(){
	pay_attention = FALSE;
	if( OpenClipboard( msgwin ) ){
		EmptyClipboard();
		if(oem_clip){ GlobalFree(oem_clip); oem_clip = NULL; oem_size = oem_len = 0; }
		if(text_clip){ GlobalFree(text_clip); text_clip = NULL; text_size = text_len = 0; }
		if(unicode_clip){ GlobalFree(unicode_clip); unicode_clip = NULL; unicode_size = unicode_len = 0; }
		CloseClipboard();
	}
	pay_attention = TRUE;
}